#ifndef ACCOUNTVIEW_H
#define ACCOUNTVIEW_H

#include <q3listview.h>
#include <qlist.h>
//Added by qt3to4:
#include <Q3ValueList>
#include <opie2/osmartpointer.h>
#include <libmailwrapper/mailtypes.h>

class Selectstore;
class Folder;
class AbstractMail;
class Account;
class IMAPviewItem;
class MHviewItem;

class AccountView : public Q3ListView
{
    Q_OBJECT

public:
    AccountView( QWidget *parent = 0, const char *name = 0, Qt::WFlags flags = 0 );
    virtual ~AccountView();
    virtual void populate( QList<Account> list );
    virtual RecBodyP fetchBody(const Opie::Core::OSmartPointer<RecMail>&aMail);
    virtual void downloadMails(const Opie::Core::OSmartPointer<Folder>&fromFolder,AbstractMail*fromWrapper);
    virtual void downloadMailsInbox(const Opie::Core::OSmartPointer<Folder>&fromFolder,AbstractMail*fromWrapper);
    virtual bool currentisDraft();
    Q3ValueList<MHviewItem*> allAccounts() { return mhAccounts;}
public slots:
    virtual void refreshAll();
    virtual void refresh(Q3ListViewItem *item);
    virtual void refreshCurrent();
    virtual void refreshCurrentSelected();
    virtual void refreshOutgoing();
    virtual void slotHold(int, Q3ListViewItem *,const QPoint&,int);
    virtual void slotContextMenu(int id);
    void setupFolderselect(Selectstore*sels);

signals:
    void refreshMailview(const Q3ValueList<RecMailP>& );

protected:
    Q3ListViewItem* m_currentItem;
    Q3ValueList<IMAPviewItem*> imapAccounts;
    Q3ValueList<MHviewItem*> mhAccounts;
};

#endif
