
// CHANGED 2004-08-06 Lutz Rogowski
#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <q3mainwindow.h>
//Added by qt3to4:
#include <Q3CString>
#include <Q3ValueList>
#include <Q3PopupMenu>
#include <klistview.h>
#include <qaction.h>
#include <qlineedit.h>

#include <q3toolbar.h>
#ifdef DESKTOP_VERSION
#include <qmenubar.h>
#define QPEMenuBar QMenuBar
#else
#include <qpe/qpemenubar.h>
#endif

#include "accountview.h"
#include "statuswidget.h"

#include <libmailwrapper/mailtypes.h>
#include <opie2/osmartpointer.h>

class RecMail;

class MainWindow : public Q3MainWindow
{
    Q_OBJECT

public:
    MainWindow( QWidget *parent = 0, const char *name = 0, Qt::WFlags flags = 0 );
    virtual ~MainWindow();

public slots:
    virtual void slotAdjustColumns();
    virtual void slotAdjustColumnsWide();
    virtual void appMessage(const Q3CString &msg, const QByteArray &data);
    virtual void slotComposeMail();

protected slots:
    virtual void setInfoFields(Q3ListViewItem* );
    virtual void slotSendQueued();
    virtual void slotEditAccounts();
    virtual void slotShowFolders( bool show );
    virtual void refreshMailView(const Q3ValueList<RecMailP>&);
    virtual void displayMail();
    virtual void slotGetMail() = 0;
    virtual void slotGetAllMail() = 0;
    virtual void slotDeleteMail();
    virtual void slotDeleteAllMail() = 0;
    virtual void slotSetCodec(int);
    virtual void mailHold(int, Q3ListViewItem *,const QPoint&,int);
    virtual void slotAdjustLayout();
    virtual void slotEditSettings();
    virtual void slotEditGlobalSettings();
    virtual void mailLeftClicked( Q3ListViewItem * );
    void showLicence();
    void showAbout();
    void showEtpanLicence(); 

protected:
    Q3ToolBar *toolBar;
    StatusWidget *statusWidget;
    QPEMenuBar *menuBar;
    Q3PopupMenu *mailMenu, *settingsMenu, *codecMenu;
    QAction *composeMail, *sendQueued, *showFolders, *searchMails, *deleteMails,
            *editSettings, *editAccounts, *syncFolders;
    AccountView *folderView;
    KListView *mailView;
    QLineEdit* toLE,*fromLE,*subLE;
    //QBoxLayout *layout;
};

#endif
